﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using ModbusDemo.windows;
using ModbusDemo;
using ModbusDemo.Modular;
using ModbusDemo.Common;
namespace ModbusDemo.MessageFormat
{
    public class ModualControl
    {
        public class Op
        {
            public ushort duration { get; set; }
            public UInt64 startTime { get; set; }
            public int d0 { get; set; }
            public int d1 { get; set; }
            public int d2 { get; set; }
            public int d3 { get; set; }
            public int d4 { get; set; }
            public int d5 { get; set; }
            public int d6 { get; set; }
            public int d7 { get; set; }
            public UInt64 ts { get; set; }
            public bool bD0HasConfig { get; set; }
            public bool bD1HasConfig { get; set; }
            public bool bD2HasConfig { get; set; }
            public bool bD3HasConfig { get; set; }
            public bool bD4HasConfig { get; set; }
            public bool bD5HasConfig { get; set; }
            public bool bD6HasConfig { get; set; }
            public bool bD7HasConfig { get; set; }
        }

        public class SsItem
        {
            public string addr { get; set; }
            public Op op { get; set; }
        }

        public class MqttRoot
        {
            public string taskId { get; set; }
            public List<SsItem> ss { get; set; }
        }
        public class ModualCntrol
        {
            public bool bStartControl;
            public byte sbModbusID;
            public byte sbModualIndex;
            public bool[] bControlData;
            public ushort usDurationTime;
            public UInt64 ulStartTime;
            public bool[] bControlBit = new bool[8];
        }
        public static List<ModualCntrol> liModuualControl = new List<ModualCntrol>();

        public static void vGetaWay_Receive_Control(string sDataString, out string stResponseData)
        {
            byte byModualIndex = 0;
            MqttRoot cControl = new MqttRoot();
            var jsonObj = new JObject();
            try
            {

                cControl = JsonConvert.DeserializeObject<MqttRoot>(sDataString);
                jsonObj = JObject.Parse(sDataString);
            }
            catch (Exception exception)
            {
                Form1.totxt.Log(exception + "Control Mqtt Parse Fail");
            }
            for (int i = 0; i < cControl.ss.Count; i++)
            {
                bool[] btReadTempData = new bool[6];
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModualCntrol cModualCntrol = new ModualCntrol
                {
                    sbModbusID = byte.Parse(cControl.ss[i].addr),
                    usDurationTime = cControl.ss[i].op.duration,
                    ulStartTime = cControl.ss[i].op.startTime
                };
                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cModualCntrol.bControlData, cModualCntrol.sbModbusID, 16, 6);
                for (byte j = 0; j < ModualPoll.byX66cNumber; j++)
                {
                    if (cModualCntrol.sbModbusID == ModualPoll.byX66cIdlist[j])
                    {
                        byModualIndex = j;
                        cModualCntrol.sbModualIndex = j;
                        break;
                    }
                    else
                    {
                        byModualIndex = 0;
                        cModualCntrol.sbModualIndex = j;
                    }
                }
                if (jsonObj["ss"][i]["op"] != null)
                {
                    if (jsonObj["ss"][i]["op"]["d0"] != null)
                    {
                        cControl.ss[i].op.bD0HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d0);
                        cModualCntrol.bControlBit[0] = true;
                    }
                    if (jsonObj["ss"][i]["op"]["d1"] != null)
                    {
                        cControl.ss[i].op.bD1HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d1);
                        cModualCntrol.bControlBit[1] = true;
                    }
                    if (jsonObj["ss"][i]["op"]["d2"] != null)
                    {
                        cControl.ss[i].op.bD2HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d2);
                        cModualCntrol.bControlBit[2] = true;
                    }
                    if (jsonObj["ss"][i]["op"]["d3"] != null)
                    {
                        cControl.ss[0].op.bD3HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d3);
                        cModualCntrol.bControlBit[3] = true;
                    }
                    if (jsonObj["ss"][i]["op"]["d4"] != null)
                    {
                        cControl.ss[i].op.bD4HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d4);
                        cModualCntrol.bControlBit[4] = true;
                    }
                    if (jsonObj["ss"][i]["op"]["d5"] != null)
                    {
                        cControl.ss[i].op.bD5HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d5);
                        cModualCntrol.bControlBit[5] = true;
                    }
                    if (jsonObj["ss"][i]["op"]["d6"] != null)
                    {
                        cControl.ss[i].op.bD6HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d6);
                        cModualCntrol.bControlBit[6] = true;
                    }
                    if (jsonObj["ss"][i]["op"]["d7"] != null)
                    {
                        cControl.ss[i].op.bD7HasConfig = true;
                        cModualCntrol.bControlData[i] = Convert.ToBoolean(cControl.ss[i].op.d7);
                        cModualCntrol.bControlBit[7] = true;
                    }
                    if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && cModualCntrol.ulStartTime <= Form1.GetTimeStamp())
                    {
                        cModualCntrol.bStartControl = true;
                        ModbusErrorCode |= ModbusComm.Modbus_WriteMultipleCoils(cModualCntrol.sbModbusID, 16, cModualCntrol.bControlData);
                        ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out btReadTempData, cModualCntrol.sbModbusID, 16, 6);
                    }
                    if (jsonObj["ss"][i]["op"]["ts"] != null)
                    {
                        jsonObj["ss"][i]["op"]["ts"] = Form1.GetTimeStamp();
                    }
                    if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                        {
                            liModuualControl.Add(cModualCntrol);
                        }
                        else if (cModualCntrol.bStartControl == false)
                        {
                            liModuualControl.Add(cModualCntrol);
                        }
                    }
                    if (cControl.ss[i].op.bD0HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d0"] = 1;
                        if (byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[0] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                            if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                                ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[0] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    else if (cControl.ss[i].op.bD0HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d0"] = 0;
                        if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[0] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[0] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                        if (!Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData) && byModualIndex != 0 && cModualCntrol.bStartControl == true)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[0] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }

                    }
                    if (cControl.ss[i].op.bD1HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d1"] = 1;
                        if (byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[1] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                            if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                                ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[1] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    else if (cControl.ss[i].op.bD1HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d1"] = 0;
                        if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[1] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[1] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                        if (!Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData) && byModualIndex != 0 && cModualCntrol.bStartControl == true)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[1] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    if (cControl.ss[i].op.bD2HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d2"] = 1;
                        if (byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[2] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                            if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                                ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[2] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    else if (cControl.ss[i].op.bD2HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d2"] = 0;
                        if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[2] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[2] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                        if (!Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData) && byModualIndex != 0 && cModualCntrol.bStartControl == true)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[2] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    if (cControl.ss[i].op.bD3HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d3"] = 1;
                        if (byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[3] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                            if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                                ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[3] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    else if (cControl.ss[i].op.bD3HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d3"] = 0;
                        if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[3] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[3] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                        if (!Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData) && byModualIndex != 0 && cModualCntrol.bStartControl == true)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[3] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    if (cControl.ss[i].op.bD4HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d4"] = 1;
                        if (byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[4] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                            if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                                ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[4] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    else if (cControl.ss[i].op.bD4HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d4"] = 0;
                        if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[4] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[4] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                        if (!Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData) && byModualIndex != 0 && cModualCntrol.bStartControl == true)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[4] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    if (cControl.ss[i].op.bD5HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d5"] = 1;
                        if (byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[5] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                            if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                                ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[5] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    else if (cControl.ss[i].op.bD5HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d5"] = 0;
                        if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && byModualIndex != 0)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[5] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[5] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                        if (Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData) && byModualIndex != 0 && cModualCntrol.bStartControl == true)
                        {
                            ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[5] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                        }
                    }
                    if (cControl.ss[i].op.bD6HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d6"] = 1;

                    }
                    else if (cControl.ss[i].op.bD6HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d6"] = 0;
                    }
                    if (cControl.ss[i].op.bD7HasConfig == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        jsonObj["ss"][i]["op"]["d7"] = 1;
                    }
                    else if (cControl.ss[i].op.bD7HasConfig == true)
                    {
                        jsonObj["ss"][i]["op"]["d7"] = 0;
                    }
                }
            }
            stResponseData = jsonObj.ToString();
        }

        public static void vControl_Poll()
        {
            while (true)
            {
                for (sbyte i = 0; i < liModuualControl.Count; i++)
                {
                    if (liModuualControl[i].bStartControl == false)
                    {
                        if (liModuualControl[i].ulStartTime <= Form1.GetTimeStamp())
                        {
                            ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                            liModuualControl[i].bStartControl = true;
                            bool[] bControlData = new bool[6];
                            bool[] btReadTempData;
                            ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bControlData, liModuualControl[i].sbModbusID, 16, 6);
                            for (sbyte j = 0; j < 6; j++)
                            {
                                if (liModuualControl[i].bControlBit[j] == true)
                                {
                                    bControlData[j] = liModuualControl[i].bControlData[j];
                                }
                                else
                                {
                                    liModuualControl[i].bControlData[j] = bControlData[j];
                                }
                                ModbusErrorCode |= ModbusComm.Modbus_WriteMultipleCoils(liModuualControl[i].sbModbusID, 16, bControlData);
                                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out btReadTempData, liModuualControl[i].sbModbusID, 16, 6);
                                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                                {
                                    for (sbyte k = 0; k < 6; k++)
                                    {
                                        if (liModuualControl[i].bControlBit[k] == true)
                                        {
                                            ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                            ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                        }
                                    }
                                }
                                else if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                                {
                                    for (sbyte k = 0; k < 6; k++)
                                    {
                                        if (liModuualControl[i].bControlBit[k] == true)
                                        {
                                            ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                            if (Enumerable.SequenceEqual(bControlData, btReadTempData))
                                                ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if ((liModuualControl[i].usDurationTime + liModuualControl[i].ulStartTime) <= Form1.GetTimeStamp())
                        {
                            ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                            bool[] bControlData = new bool[6];
                            bool[] btReadTempData;
                            ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bControlData, liModuualControl[i].sbModbusID, 16, 6);
                            for (sbyte j = 0; j < 6; j++)
                            {
                                if (liModuualControl[i].bControlBit[j] == true)
                                {
                                    bControlData[j] = !liModuualControl[i].bControlData[j];
                                }
                            }
                            ModbusErrorCode |= ModbusComm.Modbus_WriteMultipleCoils(liModuualControl[i].sbModbusID, 16, bControlData);
                            ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out btReadTempData, liModuualControl[i].sbModbusID, 16, 6);
                            if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                for (sbyte k = 0; k < 6; k++)
                                {
                                    if (liModuualControl[i].bControlBit[k] == true)
                                    {
                                        ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                        ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                    }
                                }
                            }
                            else if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                for (sbyte k = 0; k < 6; k++)
                                {
                                    if (liModuualControl[i].bControlBit[k] == true)
                                    {
                                        ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                        if (Enumerable.SequenceEqual(bControlData, btReadTempData))
                                            ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[5] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                    }
                                }
                            }
                            liModuualControl.Remove(liModuualControl[i]);
                            break;
                        }
                    }
                }
            }
        }
    }
}
